/* GtkSamba-0.3.0
 * copyright 1998 Perry Piplani
 * redistributable under the terms of the GPL:
 * http://www.gnu.org/copyleft/gpl.html
 */


#include <gtk/gtk.h>
#include <strings.h>
#include "gtksamba.h"
#include "../pix/share.xpm"
#include "../pix/delshare.xpm"
#include "../pix/delete.xpm"
#include "../pix/exit.xpm"
#include "../pix/new.xpm" 
#include "../pix/open.xpm"
#include "../pix/edit.xpm"
#include "../pix/save.xpm"




void c_insert_service_diag_ok(GtkWidget *button, gpointer data){
  SmbWin *sw;
  int row;
  char *text;

  sw=SMB_WIN(data);
 
  if(GTK_CLIST(SMB_WIN(sw)->servicelist)->selection)
    row = (int)(GTK_CLIST(sw->servicelist)->selection->data);
  else
    row=0;
    
  text=gtk_entry_get_text(GTK_ENTRY(sw->entry));

  for(; *text && isspace(*text); text++);
  
  if(strlen(text))
    smbwin_insert_service(text,sw);
  else
    make_user_mesg("Cannot insert service\nOne or more fields empty","Warning");
  
  resensitize_sw(sw);
  gtk_widget_destroy(sw->diagwin);
  sw->diagwin=NULL;
  return;
    
}

void make_insert_service_dialog(SmbWin *sw){
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *separator;
  GtkWidget *vbox;

  desensitize_sw(sw);

  sw->diagwin = gtk_dialog_new ();

  gtk_signal_connect(GTK_OBJECT(sw->diagwin), "delete_event",
                     GTK_SIGNAL_FUNC(c_param_diag_delete),
                     (gpointer) sw);
  
  gtk_window_set_title(GTK_WINDOW(sw->diagwin),"New Service");
  gtk_window_position (GTK_WINDOW (sw->diagwin),GTK_WIN_POS_CENTER);
  vbox=gtk_vbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (sw->diagwin)->vbox), 
		      vbox, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox), 10);
  gtk_widget_show (vbox);

  label = gtk_label_new("New Service");
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);

  
  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox),
		      separator, FALSE, TRUE, 5);
  gtk_widget_show (separator);

  label = gtk_label_new("Name:");
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);

  sw->entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX (vbox), 
		     sw->entry, TRUE, TRUE, 0);
  gtk_widget_show(sw->entry);
  

  button = gtk_button_new_with_label("insert");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_insert_service_diag_ok),
                     (gpointer) sw);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("cancel");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_param_diag_cancel),
                     (gpointer) sw);
  gtk_widget_show(button);


  gtk_widget_show(sw->diagwin);
  return;
}



void c_del_diag_ok(GtkWidget *button, gpointer data){
  SmbWin *sw;
  int row;

  sw=SMB_WIN(data);
  
  row = (int)(GTK_CLIST(sw->sublist)->selection->data);
  gtk_clist_remove(GTK_CLIST(sw->sublist),row);

  resensitize_sw(sw);
  

  gtk_widget_destroy(sw->diagwin);
  sw->diagwin=NULL;
  return;
  
}

void make_del_dialog(SmbWin *sw){
#ifndef HAVE_GNOME
  GtkWidget *button;
#endif
  GtkWidget *label;
  GtkWidget *vbox;
  char *text;
  int row;

  desensitize_sw(sw);

  row = (int)(GTK_CLIST(sw->sublist)->selection->data);

  gtk_clist_get_text(GTK_CLIST(sw->sublist),
			row ,0,&text);

#ifdef HAVE_GNOME

  sw->diagwin = gnome_dialog_new (text,NULL);
  vbox=gtk_vbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (sw->diagwin)->vbox), 
		      vbox, TRUE, TRUE, 10);
  gtk_container_border_width (GTK_CONTAINER (vbox), 0);
  gtk_widget_show (vbox);

#else
  sw->diagwin = gtk_dialog_new ();
  gtk_window_set_title(GTK_WINDOW(sw->diagwin),text);
  vbox=gtk_vbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (sw->diagwin)->vbox), 
		      vbox, TRUE, TRUE, 10);
  gtk_container_border_width (GTK_CONTAINER (vbox), 0);
  gtk_widget_show (vbox);

#endif

  gtk_signal_connect(GTK_OBJECT(sw->diagwin), "delete_event",
                     GTK_SIGNAL_FUNC(c_param_diag_delete),
                     (gpointer) sw);
  gtk_window_position (GTK_WINDOW (sw->diagwin),GTK_WIN_POS_CENTER);
  label = gtk_label_new("delete parameter:");
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);
  label = gtk_label_new(text);
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);


#ifdef HAVE_GNOME
  gnome_dialog_append_button_with_pixmap(GNOME_DIALOG(sw->diagwin),
					 "Delete",
					 GNOME_STOCK_MENU_CUT);
  gnome_dialog_append_button(GNOME_DIALOG(sw->diagwin),
			     GNOME_STOCK_BUTTON_CANCEL);
  gnome_dialog_button_connect(GNOME_DIALOG(sw->diagwin), 0,
			      GTK_SIGNAL_FUNC(c_del_diag_ok),
			      (gpointer) sw);
  gnome_dialog_button_connect(GNOME_DIALOG(sw->diagwin), 1,
			      GTK_SIGNAL_FUNC(c_param_diag_cancel),
			      (gpointer) sw);

#else

  button = gtk_button_new_with_label("Delete");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 10);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_del_diag_ok),
                     (gpointer) sw);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("cancel");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 10);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_param_diag_cancel),
                     (gpointer) sw);
  gtk_widget_show(button);

#endif
  
  gtk_widget_show(sw->diagwin);
  return;
}

void c_del_service_ok(GtkWidget *button, gpointer data){
  SmbWin *sw;

  sw=SMB_WIN(data);
  
  smbwin_delete_service(sw);
  
  resensitize_sw(sw);

  gtk_widget_destroy(sw->diagwin);
  sw->diagwin=NULL;
  return;
  
}

void make_del_service_dialog(SmbWin *sw){
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *vbox;
  char *text;
  int row;

  desensitize_sw(sw);

  row = (int)(GTK_CLIST(sw->servicelist)->selection->data);

  gtk_clist_get_text(GTK_CLIST(sw->servicelist),
			row ,0,&text);

  sw->diagwin = gtk_dialog_new ();
  vbox=gtk_vbox_new(FALSE,0);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (sw->diagwin)->vbox), 
		      vbox, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox), 10);
  gtk_widget_show (vbox);

  gtk_signal_connect(GTK_OBJECT(sw->diagwin), "delete_event",
                     GTK_SIGNAL_FUNC(c_param_diag_delete),
                     (gpointer) sw);
  
  gtk_window_set_title(GTK_WINDOW(sw->diagwin),text);
  gtk_window_position (GTK_WINDOW (sw->diagwin),GTK_WIN_POS_CENTER);
  label = gtk_label_new("delete service:");
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);
  label = gtk_label_new(text);
  gtk_box_pack_start (GTK_BOX (vbox), 
		      label, TRUE, TRUE, 0);
  gtk_widget_show (label);

  button = gtk_button_new_with_label("Delete");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 10);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_del_service_ok),
                     (gpointer) sw);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("cancel");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (sw->diagwin)->action_area), 
		     button, TRUE, TRUE, 10);
  gtk_signal_connect(GTK_OBJECT(button), "clicked",
                     GTK_SIGNAL_FUNC(c_param_diag_cancel),
                     (gpointer) sw);
  gtk_widget_show(button);


  
  gtk_widget_show(sw->diagwin);
  return;
}

#ifdef HAVE_GNOME
void make_user_mesg(char *message, char *title){
  if(!strcasecmp("Error",title))
    gnome_error_dialog(message);
  else if(!strcasecmp("Warning",title))
    gnome_warning_dialog(message);
  else
    gnome_ok_dialog(message);
  return;
}

#else

void make_user_mesg(char *message, char *title){
  GtkWidget *diag;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *vbox;

  diag=gtk_dialog_new ();

  gtk_signal_connect_object(GTK_OBJECT(diag), "delete_event",
                     GTK_SIGNAL_FUNC(gtk_widget_destroy),
                     GTK_OBJECT(diag));
  gtk_window_set_title(GTK_WINDOW(diag),title);
  gtk_window_position (GTK_WINDOW (diag),GTK_WIN_POS_CENTER);

  vbox=gtk_vbox_new(TRUE,10);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (diag)->vbox), 
		      vbox, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox), 20);
  gtk_widget_show (vbox);

  if(message){
    label = gtk_label_new(message);
    gtk_box_pack_start (GTK_BOX (vbox), 
			label, TRUE, TRUE, 0);
    gtk_widget_show (label);
  }

  
  button = gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX (GTK_DIALOG (diag)->action_area), 
		     button, TRUE, TRUE, 0);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			    GTK_SIGNAL_FUNC(gtk_widget_destroy),
			    GTK_OBJECT(diag));
  gtk_widget_show(button);

  gtk_widget_show(diag);

  return;
  
}

#endif

#ifdef HAVE_GNOME



void sw_main_menu(SmbWin *sw){

  GnomeUIInfo filemenu[] = {
    { GNOME_APP_UI_ITEM, 
      N_("Open Configuration File"), NULL,
      c_conf_open, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_NEW,
      's', GDK_CONTROL_MASK, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Open Alternate File"), NULL,
      c_alt_open, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN,
      'o', GDK_CONTROL_MASK, NULL},    
    { GNOME_APP_UI_ITEM,
      N_("Open From Server"), NULL,
      NULL, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_JUMP_TO,
      0, 0, NULL},    
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM, 
      N_("Write to Current File"), NULL,
      c_write_conf, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE,
      'w', GDK_CONTROL_MASK, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Write to Alternate File"), NULL,
      c_write_alt, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE_AS,
      'a', GDK_CONTROL_MASK, NULL},    
    { GNOME_APP_UI_ITEM,
      N_("Write to Server"), NULL,
      NULL,NULL,NULL,
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_JUMP_TO,
      0, 0, NULL},    
    GNOMEUIINFO_SEPARATOR,  
    { GNOME_APP_UI_ITEM,
      N_("Preferences"), NULL,
      c_make_pref_box, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PREF,
      'p', GDK_CONTROL_MASK, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM,
      N_("Close"), NULL,
      c_smbwin_close, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CLOSE,
      'c', GDK_CONTROL_MASK, NULL}, 
    { GNOME_APP_UI_ITEM,
      N_("New Window"), NULL,
      c_smbwin_new, sw, NULL, 
      GNOME_APP_PIXMAP_NONE, NULL,
      0,0, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Exit"), NULL,
      c_make_exit_dialog, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_QUIT,
      'q', GDK_CONTROL_MASK, NULL},
    GNOMEUIINFO_END
  };

  GnomeUIInfo editmenu[] = {
    { GNOME_APP_UI_ITEM,
      N_("Edit Parameter"), NULL,
      c_edit_param, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PROP,
      'e', GDK_CONTROL_MASK, NULL},
    { GNOME_APP_UI_ITEM,
      N_("New Parameter"), NULL,
      c_make_inserter, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_COPY,
      'i', GDK_CONTROL_MASK , NULL},
    { GNOME_APP_UI_ITEM,
      N_("New Service"), NULL,
      c_insert_service, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PASTE,
      'n',GDK_CONTROL_MASK, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM,
      N_("Delete Parameter"), NULL,
      c_delete_param, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CUT,
      'd', GDK_CONTROL_MASK, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Delete Service"), NULL,
      c_delete_service, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CUT,
      0, 0, NULL},
    GNOMEUIINFO_END
  };

  GnomeUIInfo optionsmenu[] = {
    { GNOME_APP_UI_ITEM,
      N_("Run testparm"), NULL,
      c_run_testparm, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXEC,
      't', GDK_CONTROL_MASK, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Run smbstatus"), NULL,
      c_run_smbstatus, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SEARCH,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Restart Samba"), NULL,
      c_restart_samba, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH,
      0, 0, NULL},
    GNOMEUIINFO_END
  };

  GnomeUIInfo helpmenu[] = {
    { GNOME_APP_UI_ITEM,
      N_("smb.conf(5)"), NULL,
      c_make_overview, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_OPEN,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM,
      N_("testparm(1)"), NULL,
      c_man_testparm, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_OPEN,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM,
      N_("smbstatus(1)"), NULL,
      c_man_smbstatus, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_OPEN,
      0, 0, NULL}, 
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM,
      N_("Selected Parameter"), NULL,
      c_help_sel_param, sw, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_INDEX,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM,
      N_("Look Up Parameter"), NULL,
      c_make_param_lookup, NULL, NULL, 
      GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_INDEX,
      0, 0, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM,
      N_("About"), NULL,
      c_help_about, NULL, NULL, 
      GNOME_APP_PIXMAP_NONE, NULL,
      0, 0, NULL},
    GNOMEUIINFO_END
  };

  GnomeUIInfo mainmenu[] = {
    GNOMEUIINFO_SUBTREE(N_("_File"), filemenu),
    GNOMEUIINFO_SUBTREE(N_("_Edit"), editmenu),
    GNOMEUIINFO_SUBTREE(N_("_Options"), optionsmenu),
    GNOMEUIINFO_SUBTREE(N_("_Help"), helpmenu),
    GNOMEUIINFO_END
  };

  gnome_app_create_menus(GNOME_APP(sw->window), mainmenu);
  return;

}
   
#else

#if (GTK_MINOR_VERSION < 1)

void sw_main_menu(SmbWin *sw){
  GtkWidget *menubar;
  GtkWidget *menubox;

  GtkMenuEntry menu_items[] = {
    {"<Main>/File/Open Configuration File", "<control>S", c_conf_open, sw},
    {"<Main>/File/Open Alternate File", "<control>O", c_alt_open, sw},
    {"<Main>/File/Open From Server", "<control>N", NULL, NULL},
    {"<Main>/File/<separator>", NULL, NULL, NULL},
    {"<Main>/File/Write to Current File", "<control>W", c_write_conf, sw},
    {"<Main>/File/Write to Alternate File", "<control>A", c_write_alt, sw},
    {"<Main>/File/Write to Server", "<control>T", NULL, NULL},
    {"<Main>/File/<separator>", NULL, NULL, NULL},
    {"<Main>/File/Close", "<control>C", c_smbwin_close, sw},
    {"<Main>/File/New Window", NULL, c_smbwin_new, NULL},
    {"<Main>/File/Quit", "<control>Q", c_make_exit_dialog, sw},
    {"<Main>/Edit/Edit Parameter", NULL, c_edit_param, sw},
    {"<Main>/Edit/New Parameter", NULL, c_make_inserter, sw},
    {"<Main>/Edit/New Service", NULL, c_insert_service, sw},
    {"<Main>/Edit/<separator>", NULL, NULL, NULL},
    {"<Main>/Edit/Delete Parameter", NULL, c_delete_param, sw},
    {"<Main>/Edit/Delete Service", NULL, c_delete_service, sw},
    {"<Main>/Options/Preferences", NULL, c_make_pref_box, NULL},
    {"<Main>/Options/<separator>", NULL, NULL, NULL},
    {"<Main>/Options/Run testparm", NULL, c_run_testparm, sw},
    {"<Main>/Options/Run smbstatus", NULL, c_run_smbstatus, NULL},
    {"<Main>/Options/Restart Samba", NULL, c_restart_samba, NULL},
    {"<Main>/Help/Overview", NULL, c_make_overview, NULL},
    {"<Main>/Help/Selected Parameter", NULL, c_help_sel_param, sw},
    {"<Main>/Help/Look Up Parameter", NULL, c_make_param_lookup, NULL},
    {"<Main>/Help/<separator>", NULL, NULL, NULL},
    {"<Main>/Help/About", NULL, c_help_about, sw},
  };

  int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
  GtkMenuFactory *factory;
  GtkMenuFactory *subfactory;

  factory = gtk_menu_factory_new(GTK_MENU_FACTORY_MENU_BAR);
  subfactory = gtk_menu_factory_new(GTK_MENU_FACTORY_MENU_BAR);
  
  gtk_menu_factory_add_subfactory(factory, subfactory, "<Main>");
  gtk_menu_factory_add_entries(factory, menu_items, nmenu_items);
  
 
  menubar = subfactory->widget;
  menubox = gtk_handle_box_new();
  gtk_container_add(GTK_CONTAINER(menubox), menubar);
  gtk_box_pack_start(GTK_BOX(sw->vbox), menubox, FALSE, TRUE, 0);
  gtk_widget_show(menubox);
  gtk_widget_show(menubar);
}

#else

  
void sw_main_menu(SmbWin *sw){
  GtkWidget *menubar;
  GtkWidget *menubox;
  GtkAccelGroup *accel;
  GtkItemFactory *factory;

  GtkItemFactoryEntry menu_items[] = {
    {"/_File", "<alt>F", NULL, 0, "<Branch>"},
    {"/File/Open Configuration File", "<control>S", c_conf_open, 0},
    {"/File/Open Alternate File", "<control>O", c_alt_open, 0},
    {"/File/Open From Server", NULL, NULL, 0},

    {"/File/sep1", NULL, NULL, 0, "<Separator>"},
    {"/File/Write to Current File", "<control>W", c_write_conf, 0},
    {"/File/Write to Alternate File", "<control>A", c_write_alt, 0},
    {"/File/Write to Server", NULL, NULL, 0},

    {"/File/sep2", NULL, NULL, 0, "<Separator>"},
    {"/File/Preferences", "<control>P", c_make_pref_box, 0},

    {"/File/sep3", NULL, NULL, 0, "<Separator>"},
    {"/File/Close", "<control>C", c_smbwin_close, 0},
    {"/File/New Window", NULL, c_smbwin_new, 0},
    {"/File/Quit", "<control>Q", c_make_exit_dialog, 0},

    {"/_Edit","<alt>E", NULL, 0, "<Branch>"},
    {"/Edit/Edit Parameter", "<control>E", c_edit_param, 0},
    {"/Edit/New Parameter", "<control>I", c_make_inserter, 0},
    {"/Edit/New Service", "<control>N", c_insert_service, 0},

    {"/Edit/sep1", NULL, NULL, 0, "<Separator>"},
    {"/Edit/Delete Parameter", "<control>D", c_delete_param, 0},
    {"/Edit/Delete Service", NULL, c_delete_service, 0},

    {"/_Options", "<alt>O", NULL, 0, "<Branch>"},
    {"/Options/Run testparm","<control>T" , c_run_testparm, 0},
    {"/Options/Run smbstatus", NULL, c_run_smbstatus, 0},
    {"/Options/Restart Samba", NULL, c_restart_samba, 0},

    {"/_Help", "<alt>H", NULL, 0, "<Branch>"},
    {"/Help/smb.conf Overview", NULL, c_make_overview, 0},
    {"/Help/testparm(1)", NULL, c_man_testparm, 0},
    {"/Help/smbstatus(1)", NULL, c_man_smbstatus, 0},
    {"/Help/sep1", NULL, NULL, 0, "<Separator>"},
    {"/Help/Selected Parameter", NULL, c_help_sel_param, 0},
    {"/Help/Look Up Parameter", NULL, c_make_param_lookup, 0},

    {"/Help/sep2", NULL, NULL, 0, "<Separator>"},
    {"/Help/About", NULL, c_help_about, 0},
  };

  int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
  

  accel = gtk_accel_group_new();
  factory = gtk_item_factory_new( GTK_TYPE_MENU_BAR, "<Main>", accel );
  gtk_item_factory_create_items_ac(factory, nmenu_items, 
				   menu_items, sw, 2);
  


  menubar = gtk_item_factory_get_widget( factory, "<Main>" );
  menubox = gtk_handle_box_new();
  gtk_accel_group_attach( accel, GTK_OBJECT( sw->window ) );
  gtk_container_add(GTK_CONTAINER(menubox), menubar);
  gtk_box_pack_start(GTK_BOX(sw->vbox), menubox, FALSE, TRUE, 0);
  gtk_widget_show(menubox);
  gtk_widget_show(menubar);
}

#endif
#endif

#ifdef HAVE_GNOME

void sw_toolbars(SmbWin *sw){
  GnomeUIInfo toolbar[] = {
    { GNOME_APP_UI_ITEM, 
      N_("Open"), N_("Open Configuration"),
      GTK_SIGNAL_FUNC(c_alt_open), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, open_xpm,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM, 
      N_("Write"), N_("Write Configuration"),
      GTK_SIGNAL_FUNC(c_write_alt), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, save_xpm,
      0, 0, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM, 
      N_("Insert"), N_("Insert Service"),
      GTK_SIGNAL_FUNC(c_insert_service), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, share_xpm,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM, 
      N_("Delete"), N_("Delete Service"),
      GTK_SIGNAL_FUNC(c_delete_service), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, delshare_xpm,
      0, 0, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM, 
      N_("Edit"), N_("Edit Parameter"),
      GTK_SIGNAL_FUNC(c_edit_param), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, edit_xpm,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM, 
      N_("Insert"), N_("Insert Parameter"),
      GTK_SIGNAL_FUNC(c_make_inserter), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, new_xpm,
      0, 0, NULL},
    { GNOME_APP_UI_ITEM, 
      N_("Delete"), N_("Delete Parameter"),
      GTK_SIGNAL_FUNC(c_delete_param), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, delete_xpm,
      0, 0, NULL},
    GNOMEUIINFO_SEPARATOR,
    { GNOME_APP_UI_ITEM, 
      N_("Exit"), N_("Quit Program"),
      GTK_SIGNAL_FUNC(c_make_exit_dialog), sw, NULL, 
      GNOME_APP_PIXMAP_DATA, exit_xpm,
      0, 0, NULL},
    GNOMEUIINFO_END
  };
  gnome_app_create_toolbar(GNOME_APP(sw->window), toolbar);
  return;
}

    
#else

GtkWidget* make_pixmap(char **xpm,GtkWidget* window){
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  gtk_widget_realize(window);
  style = gtk_widget_get_style( window );
  pixmap = gdk_pixmap_create_from_xpm_d( window->window,  &mask,
					 &style->bg[GTK_STATE_NORMAL],
					 xpm);

  /* a pixmap widget to contain the pixmap */
  pixmapwid = gtk_pixmap_new( pixmap, mask );
  return pixmapwid;
}


void sw_toolbars(SmbWin *sw){
  GtkWidget *toolbar;
  GtkWidget *toolbox;

  toolbar=gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,
			  GTK_TOOLBAR_BOTH);
  gtk_toolbar_set_space_size(GTK_TOOLBAR(toolbar),20);

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Open","Open Configuration","",
			  make_pixmap(open_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_alt_open), sw);

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Write","Write Configuration","",
			  make_pixmap(save_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_write_alt), sw);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Insert","Insert Service","",
			  make_pixmap(share_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_insert_service), sw);
  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Delete","Delete Service","",
			  make_pixmap(delshare_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_delete_service), sw);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Edit","Edit Parameter","",
			  make_pixmap(edit_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_edit_param), sw);

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Insert","Insert Parameter","",
			  make_pixmap(new_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_make_inserter), sw);
  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Delete","Delete Parameter","",
			  make_pixmap(delete_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_delete_param), sw);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
  
  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
			  "Exit","Quit Program","",
			  make_pixmap(exit_xpm,sw->window),
			  GTK_SIGNAL_FUNC(c_make_exit_dialog), sw);




  toolbox = gtk_handle_box_new();
  gtk_container_add(GTK_CONTAINER(toolbox), toolbar);
  gtk_box_pack_start(GTK_BOX(sw->vbox), toolbox, FALSE, TRUE, 0);
  gtk_widget_show(toolbox);
  gtk_widget_show(toolbar);

}
#endif

  
